package dictionary;

public interface Dictionary<D> {
   
   /**
    * returns the data that is stored under given key; null is returned in 
    * case there is no data.
    * @param key
    */
   D get(int key);

   /**
    * stores the data under the given key, overwrites 
    * existing data which was stored under that key.
    * @param key
    * @param data
    */
   void put(int key, D data);
   
   /**
    * removes entry for given key, if such an entry exists
    * @param key
    */
   void remove(int key);
   
   
   /** 
    * returns an iterator over the Dictionary
    */
   Iterator<D> iterator();
}
