package trees;

import dictionary.*;

public class SplayTree<D> implements Dictionary<D> {
   Node<D> root;

   public D get(int key) {
      //TODO: Insert code
   }

   public void put(int key, D data) {
      //TODO: Insert code
   }

   public void remove(int key) {
      splay(this.root, key);
      if (this.root != null && this.root.key == key) {
         if (this.root.left == null) {
            this.root = this.root.right;
            if (this.root != null) {
               this.root.parent = null;
            }
         } else {
            splay(this.root.left, key);
            Node<D> left = this.root.left;
            left.right = this.root.right;
            this.root = left;
            this.root.parent = null;
            if (left.right != null) {
               left.right.parent = left;
            }
         }
      }
   }


   /*
    * as in BinTree, except that one can pass a starting 
    * root as argument
    */
   private Node<D> find(Node<D> root, int key) {
      Node<D> current = root;
      Node<D> previous = null;
      while (current != null) {
         previous = current;
         if (key < current.key) {
            current = current.left;
         } else if (key == current.key) {
            return current;
         } else {
            current = current.right;
         }
      }
      return previous; 
   }

   private void rotateRight(Node<D> p) {
      Node<D> l = p.left;
      l.parent = p.parent;
      p.left = l.right;
      l.right = p;
      p.parent = l;
      if (p.left != null) {
         p.left.parent = p;
      }
      if (l.parent == null) {
         this.root = l;
      } else if (l.parent.left == p) {
         l.parent.left = l;
      } else {
         l.parent.right = l;
      }
   }

   private void rotateLeft(Node<D> p) {
      Node<D> r = p.right;
      r.parent = p.parent;
      p.right = r.left;
      r.left = p;
      p.parent = r;
      if (p.right != null) {
         p.right.parent = p;
      }
      if (r.parent == null) {
         this.root = r;
      } else if (r.parent.left == p) {
         r.parent.left = r;
      } else {
         r.parent.right = r;
      }      
   }
   
   private void splay(Node<D> root, int x) {
     //TODO: Insert code
   }

   public Iterator<D> iterator() {      
      return new TreeIterator<D>(this.root, TreeIterator.INORDER);
   }
   
   /* For: System.out.println(tree)
   */
   public String toString() {
      String res = "(";
      Iterator<D> it = iterator();
      while(it.hasNext()) {
         Entry<D> en = it.next();
         res += "[" + en.key + ":" + en.data + "]";
         if (it.hasNext()) res += ",";
      }
      return res + ")";
   }

   public static <D> SplayTree<D> create(int[] a) {
      SplayTree<D> t = new SplayTree<D>();
      for (int i : a) {
         t.put(i, null);
      }
      return t;
   }
}
